package com.minemaarten.signals.client.gui;

import java.awt.Point;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.client.resources.I18n;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;

import org.lwjgl.opengl.GL11;

import com.minemaarten.signals.capabilities.destinationproviders.DestinationProviderItems;
import com.minemaarten.signals.client.gui.widget.GuiButtonSpecial;
import com.minemaarten.signals.inventory.ContainerItemHandlerDestination;

public class GuiItemHandlerDestination extends GuiContainerBase<TileEntity>{

    private GuiButtonSpecial damageButton, nbtButton, modButton, oreDictButton, blacklistButton;

    public GuiItemHandlerDestination(TileEntity te){
        super(new ContainerItemHandlerDestination(te), null, null);
        DestinationProviderItems p = ((ContainerItemHandlerDestination)field_147002_h).provider;
        field_146999_f = Math.max(78, Minecraft.func_71410_x().field_71466_p.func_78256_a(p.getLocalizedName()) + 2);
        field_147000_g = 68;
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();

        damageButton = new GuiButtonSpecial(0, field_147003_i + 5, field_147009_r + 18, 20, 20, "").setRenderStacks(new ItemStack(Items.field_151035_b));
        damageButton.setTooltipText("Damage");

        nbtButton = new GuiButtonSpecial(1, field_147003_i + 27, field_147009_r + 18, 20, 20, "").setRenderStacks(new ItemStack(Items.field_151134_bR));
        nbtButton.setTooltipText("NBT");

        modButton = new GuiButtonSpecial(2, field_147003_i + 5, field_147009_r + 40, 20, 20, "Mod");
        modButton.setTooltipText("Mod similarity");

        oreDictButton = new GuiButtonSpecial(3, field_147003_i + 27, field_147009_r + 40, 20, 20, "").setRenderStacks(new ItemStack(Items.field_151042_j));
        oreDictButton.setTooltipText("Ore Dictionary");

        blacklistButton = new GuiButtonSpecial(4, field_147003_i + 53, field_147009_r + 30, 20, 20, "").setRenderStacks(new ItemStack(Items.field_151100_aR, 1, 0));
        blacklistButton.setTooltipText("Whitelist");

        addWidget(damageButton);
        addWidget(nbtButton);
        addWidget(modButton);
        addWidget(oreDictButton);
        addWidget(blacklistButton);
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        DestinationProviderItems p = ((ContainerItemHandlerDestination)field_147002_h).provider;

        blacklistButton.setRenderStacks(new ItemStack(Items.field_151100_aR, 1, p.blacklist ? 0 : 15));
        blacklistButton.setTooltipText(I18n.func_135052_a(String.format("signals.gui.destination_provider.items.%s", p.blacklist ? "blacklist" : "whitelist")));

        damageButton.setTooltipText(I18n.func_135052_a(String.format("signals.gui.destination_provider.items.%s_damage", p.checkDamage ? "check" : "ignore")));
        nbtButton.setTooltipText(I18n.func_135052_a(String.format("signals.gui.destination_provider.items.%s_nbt", p.checkNBT ? "check" : "ignore")));
        modButton.setTooltipText(I18n.func_135052_a(String.format("signals.gui.destination_provider.items.%s_mod_similarity", p.checkModSimilarity ? "check" : "ignore")));
        oreDictButton.setTooltipText(I18n.func_135052_a(String.format("signals.gui.destination_provider.items.%s_ore_dictionary", p.checkOreDictionary ? "check" : "ignore")));
    }

    @Override
    protected boolean shouldDrawBackground(){
        return false;
    }

    @Override
    protected Point getInvTextOffset(){
        return null;
    }

    @Override
    protected void func_146976_a(float partialTicks, int i, int j){
        drawBackLayer();
        DestinationProviderItems p = ((ContainerItemHandlerDestination)field_147002_h).provider;
        func_73734_a(field_147003_i, field_147009_r, field_147003_i + field_146999_f, field_147009_r + 12, 0xFF222222);
        drawDarkGreyTextCentered(field_147003_i + field_146999_f / 2, field_147009_r, p.getLocalizedName());
        super.func_146976_a(partialTicks, i, j);
        if(!p.checkDamage) drawRedCross(damageButton.field_146128_h + 2, damageButton.field_146129_i + 2);
        if(!p.checkNBT) drawRedCross(nbtButton.field_146128_h + 2, nbtButton.field_146129_i + 2);
        if(!p.checkModSimilarity) drawRedCross(modButton.field_146128_h + 2, modButton.field_146129_i + 2);
        if(!p.checkOreDictionary) drawRedCross(oreDictButton.field_146128_h + 2, oreDictButton.field_146129_i + 2);
    }

    private static void drawRedCross(int x, int y){
        int size = 16;
        Tessellator tessellator = Tessellator.func_178181_a();
        BufferBuilder bufferBuilder = tessellator.func_178180_c();
        GlStateManager.func_179090_x();
        GlStateManager.func_179097_i();
        GlStateManager.func_179124_c(1, 0, 0);
        bufferBuilder.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181705_e);

        bufferBuilder.func_181662_b(x, y + 1, 0.0D).func_181675_d();
        bufferBuilder.func_181662_b(x + size - 1, y + size, 0.0D).func_181675_d();
        bufferBuilder.func_181662_b(x + size, y + size - 1, 0.0D).func_181675_d();
        bufferBuilder.func_181662_b(x + 1, y, 0.0D).func_181675_d();

        bufferBuilder.func_181662_b(x, y + size - 1, 0.0D).func_181675_d();
        bufferBuilder.func_181662_b(x + 1, y + size, 0.0D).func_181675_d();
        bufferBuilder.func_181662_b(x + size, y + 1, 0.0D).func_181675_d();
        bufferBuilder.func_181662_b(x + size - 1, y, 0.0D).func_181675_d();

        tessellator.func_78381_a();
        GlStateManager.func_179098_w();
        GlStateManager.func_179126_j();
    }
}
